Run the mount command inside config_fstab only if "$NOSWAP" is not set
[grml-autoconfig.git] / autoconfig.functions
1 #!/bin/zsh
2 # Filename:      autoconfig.functions
3 # Purpose:       basic system configuration and hardware setup for grml system
4 # Authors:       grml-team (grml.org), (c) Klaus Knopper <knopper@knopper.net>, (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 # Latest change: Mon Feb 19 18:59:09 CET 2007 [mika]
8 ################################################################################
9
10 # {{{ path, variables, signals, umask, zsh
11 export PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin"
12 DEBUG="/dev/null"
13 KERNEL="$(uname -r)"
14 umask 022
15
16 # Ignore these signals in non-interactive mode: INT, TERM, SEGV
17 [ -z "$PS1" ] && trap "" 2 3 11
18
19 # zsh stuff
20 iszsh(){
21 if [ -n "$ZSH_VERSION" ] ; then
22   return 0
23 else
24   return 1
25 fi
26 }
27 # avoid 'no matches found: ...'
28 iszsh && setopt no_nomatch # || echo "Warning: not running under zsh!"
29 # }}}
30
31 ### {{{ Utility Functions
32
33 # Simple shell grep
34 stringinfile(){
35   case "$(cat $2)" in *$1*) return 0;; esac
36   return 1
37 }
38
39 # same for strings
40 stringinstring(){
41   case "$2" in *$1*) return 0;; esac
42   return 1
43 }
44
45 # Reread boot command line; echo last parameter's argument or return false.
46 getbootparam(){
47   stringinstring " $1=" "$CMDLINE" || return 1
48   result="${CMDLINE##*$1=}"
49   result="${result%%[   ]*}"
50   echo "$result"
51   return 0
52 }
53
54 # Check boot commandline for specified option
55 checkbootparam(){
56   stringinstring " $1" "$CMDLINE"
57   return "$?"
58 }
59
60 checkvalue(){
61   if [ "$1" = "yes" ] ; then
62     return 0
63   else
64     return 1
65   fi
66 }
67
68 checkgrmlsmall(){
69   grep -q small /etc/grml_version 2>>$DEBUG && return 0 || return 1
70 }
71
72 checkgrmlusb(){
73   grep -q usb /etc/grml_version 2>>$DEBUG && return 0 || return 1
74 }
75 ### }}}
76
77 # {{{ filesystems (proc, pts, sys) and fixes
78 mount_proc(){
79   [ -f /proc/version ] || mount -t proc /proc /proc 2>/dev/null
80 }
81
82 mount_pts(){
83   stringinfile "/dev/pts" /proc/mounts || mount -t devpts /dev/pts /dev/pts 2>/dev/null
84 }
85
86 mount_sys(){
87   [ -d /sys/devices ] || mount -t sysfs /sys /sys 2>/dev/null
88 }
89 # }}}
90
91 # {{{ Read in boot parameters
92 [ -f /proc/version ] || mount_proc # make sure we can access /proc/cmdline when sourcing this file too
93 CMDLINE="$(cat /proc/cmdline)"
94 [ -d /cdrom/bootparams/ ] && CMDLINE="$CMDLINE $(cat /cdrom/bootparams/* | tr '\n' ' ')"
95 # }}}
96
97 # {{{ Check if we are running from the grml-CD or HD
98 INSTALLED=""
99 [ -e /GRML/etc/grml_cd ] || INSTALLED="yes"
100
101 # testcd
102 TESTCD=""
103 checkbootparam "testcd" >>$DEBUG 2>&1 && TESTCD="yes"
104 # }}}
105
106 # {{{ source lsb-functions , color handling
107 if checkbootparam "nocolor"; then
108   RC_NOCOLOR=yes
109   . /etc/grml/lsb-functions
110   einfo "Disabling colors in bootsequence as requested on commandline." ; eend 0
111 else
112   . /etc/grml/lsb-functions
113   . /etc/grml_colors
114 fi
115 # }}}
116
117 # {{{ debug
118 config_debug(){
119  if checkbootparam "debug"; then
120    BOOTDEBUG="yes"
121  fi
122  if stringinstring "BOOT_IMAGE=debug " "$CMDLINE" ; then
123    BOOTDEBUG="yes"
124  fi
125  rundebugshell(){
126   if [ -n "$BOOTDEBUG" ]; then
127     einfo "Starting intermediate shell stage $stage as requested by \"debug\" option."
128     eindent
129     if [ -r /etc/grml/screenrc ] ; then
130        einfo "Starting GNU screen to be able to use a full featured shell environment."
131        einfo "Just exit the shells (and therefore screen) to continue boot process..."
132        /bin/zsh -c "screen -c /etc/grml/screenrc"
133     else
134       einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
135       einfo "Just exit the shell to continue boot process..."
136       /bin/zsh
137     fi
138     eoutdent
139   fi
140  }
141 }
142 # }}}
143
144 # {{{ log
145 config_log(){
146 if checkbootparam "log"; then
147   export DEBUG="/tmp/grml.log.`date +%Y%m%d`"
148   touch $DEBUG
149   einfo "Bootparameter log found. Log files: ${DEBUG} and /var/log/boot."
150   eindent
151     einfo "Starting bootlogd."
152     bootlogd -r -c 1>>$DEBUG 2>&1 ; eend $?
153   eoutdent
154 else
155   DEBUG="/dev/null"
156 fi
157 }
158 # }}}
159
160 # {{{ Check if we are in interactive startup mode
161 INTERACTIVE=""
162 stringinstring "BOOT_IMAGE=expert " "$CMDLINE" && INTERACTIVE="yes"
163 # }}}
164
165 # {{{ set firmware timeout via bootparam
166 config_fwtimeout(){
167  if checkbootparam fwtimeout ; then
168    TIMEOUT="$(getbootparam 'fwtimeout' 2>>$DEBUG)"
169    einfo "Bootoption fwtimeout found. (Re)Loading firmware_class module."
170    rmmod firmware_class 1>>$DEBUG 2>&1
171    modprobe firmware_class ; eend $?
172  fi
173  if [ -z "$TIMEOUT" ] ; then
174    TIMEOUT="100" # linux kernel default: 10
175  fi
176  if [ -f /sys/class/firmware/timeout ] ; then
177    einfo "Setting timeout for firmware loading to ${TIMEOUT}."
178    echo 100 > /sys/class/firmware/timeout ; eend $?
179  fi
180 }
181 # }}}
182
183 ### {{{ language configuration / localization
184 config_language(){
185
186  einfo "Activating language settings:"
187  eindent
188
189  # people can specify $LANGUAGE and $CONSOLEFONT in a config file:
190  [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
191
192  grep -q ' lang=.*-utf8' /proc/cmdline && UTF8='yes' || UTF8=''
193
194  # check for bootoption which overrides config from /etc/grml/autoconfig:
195  BOOT_LANGUAGE="$(getbootparam lang 2>>$DEBUG)"
196  [ -n "$BOOT_LANGUAGE" ] && LANGUAGE="$BOOT_LANGUAGE"
197
198  # set default to 'en' in live-cd mode if $LANGUAGE is not yet set:
199  if [ -z "$INSTALLED" ] ; then
200     [ -n "$LANGUAGE" ] || LANGUAGE='en-utf8'
201  fi
202
203  # if bootoption lang is used update /etc/default/locale, otherwise *not*!
204  if [ -n "$BOOT_LANGUAGE" ] ; then
205     [ -x /usr/sbin/grml-setlang ] && /usr/sbin/grml-setlang "$LANGUAGE"
206  fi
207
208  # set console font
209  if [ -z "$CONSOLEFONT" ] ; then
210     if ! checkbootparam "nodefaultfont" >>$DEBUG 2>&1 ; then
211        # [ -n "$UTF8" ] && CONSOLEFONT='LatArCyrHeb-16' || CONSOLEFONT='Lat15-Terminus16'
212        # if [ -r /usr/share/consolefonts/Lat15-Terminus16.psf.gz ] ; then
213        if [ -r /usr/share/consolefonts/Uni3-Terminus16.psf.gz ] ; then
214           CONSOLEFONT='Uni3-Terminus16'
215        else
216           ewarn "/usr/share/consolefonts/Uni3-Terminus16.psf.gz not available. Please upgrade package console-terminus." ; eend 1
217        fi
218     fi
219  fi
220
221  # export it now, so error messages get translated, too
222  if checkgrmlsmall ; then
223     export LANG='C' # grml-small does not provide any further locales
224  else
225     [ -r /etc/default/locale ] && . /etc/default/locale
226     export LANG LANGUAGE
227  fi
228
229  # configure keyboard layout, read in already set values first:
230  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
231
232  # now allow keyboard override by boot commandline for later use:
233  KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
234  [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
235  # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
236  [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
237  [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
238
239  # modify /etc/sysconfig/keyboard only in live-cd mode:
240  if [ -z "$INSTALLED" ] ; then
241
242    local LANGUAGE="$BOOT_LANGUAGE"
243    . /etc/grml/language-functions
244    # allow setting xkeyboard explicitly different than console keyboard
245    KXKEYBOARD="$(getbootparam xkeyboard 2>>$DEBUG)"
246    if [ -n "$KXKEYBOARD" ]; then
247       XKEYBOARD="$KXKEYBOARD"
248       KDEKEYBOARD="$KXKEYBOARD"
249    elif [ -n "$KKEYBOARD" ]; then
250       XKEYBOARD="$KKEYBOARD"
251       KDEKEYBOARD="$KKEYBOARD"
252    fi
253
254    # duplicate of previous code to make sure /etc/grml/language-functions
255    # does not overwrite our values....
256    # now allow keyboard override by boot commandline for later use:
257    KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
258    [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
259    # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
260    [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
261    [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
262
263    # write keyboard related variables to file for later use
264    echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
265    echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
266    echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
267    echo "KDEKEYBOARDS=\"$KDEKEYBOARDS\"" >> /etc/sysconfig/keyboard
268  fi
269
270  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
271
272   # Set default keyboard before interactive setup
273   if [ -n "$KEYTABLE" ] ; then
274    einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
275    loadkeys -q $KEYTABLE &
276    eend $?
277   fi
278
279   if [ -n "$CONSOLEFONT" ] ; then
280      einfo "Running consolechars using ${CONSOLEFONT}"
281      consolechars -f $CONSOLEFONT || consolechars -d
282      eend $?
283   fi
284
285   # we have to set up all consoles, therefore loop it over all ttys:
286   if [ -n "$CHARMAP" ] ; then
287      einfo "Running consolechars for ${CHARMAP}"
288      NUM_CONSOLES=`fgconsole --next-available`
289      NUM_CONSOLES=`expr ${NUM_CONSOLES} - 1`
290      [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
291      for vc in `seq 0 ${NUM_CONSOLES}`  ; do
292        consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
293      done
294      eend ${RC}
295   fi
296
297   # activate unicode console if running within utf8 environment
298   if [ -r /etc/default/locale ] ; then
299      if grep -q "LANG=.*UTF" /etc/default/locale ; then
300         einfo "Setting up unicode environment."
301         unicode_start
302         eend $?
303      fi
304   fi
305
306  eoutdent
307 }
308 # }}}
309
310 # {{{ Set hostname
311 config_hostname(){
312  if checkbootparam hostname ; then
313   HOSTNAME="$(getbootparam 'hostname' 2>>$DEBUG)"
314   einfo "Setting hostname to $HOSTNAME as requested."
315   sed -i "s/^127.0.0.1.*localhost/127.0.0.1 $HOSTNAME localhost/" /etc/hosts
316   hostname $HOSTNAME ; eend $?
317  else
318   hostname --file /etc/hostname
319  fi
320 }
321 # }}}
322
323 # fstabuser (needed when running from harddisk with username != grml {{{
324 config_userfstab(){
325   [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
326   if [ -n "$CONFIG_FSTAB_USER" ] ; then
327      fstabuser="$CONFIG_FSTAB_USER"
328   else
329      fstabuser=$(getent passwd 1000 | cut -d: -f1)
330   fi
331   # if not yet set fall back to default 'grml' user
332   [ -n "$fstabuser" ] || fstabuser='grml'
333 }
334 # }}}
335
336 # {{{ Set clock (Local time is more often used than GMT, so it is default)
337 config_time(){
338  # don't touch the files if running from harddisk:
339  if [ -z "$INSTALLED" ]; then
340   UTC=""
341   checkbootparam utc >>$DEBUG 2>&1 && UTC="-u"
342   checkbootparam gmt >>$DEBUG 2>&1 && UTC="-u"
343   # hwclock uses the TZ variable
344   if [ -r /etc/default/locale ] ; then
345      . /etc/default/locale
346   else
347      TZ=Europe/Vienna
348   fi
349   ERROR=$(TZ="$TZ" hwclock $UTC -s 2>&1) ; RC=$?
350   if [ -n "$ERROR" ] ; then
351      eindent
352      ERROR=$(TZ="$TZ" hwclock $UTC -s --directisa 2>&1)
353      if [ -n "$ERROR" ] ; then
354         eerror "Problem running hwclock: $ERROR" ; eend 1
355      fi
356      eoutdent
357   fi
358  fi
359 }
360 # }}}
361
362 # {{{ print kernel info
363 config_kernel(){
364   vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMWare${NORMAL}"
365   [ -d /proc/xen ] && VMWARE='' # vmware-detect returns '0' when running with a Xen-enabled kernel
366   einfo "Running Linux Kernel $KERNEL $VMWARE" ; eend 0
367   if [ -r /proc/cpuinfo ] ; then
368      if egrep -q '^flags.*(vmx|svm)' /proc/cpuinfo ; then
369        eindent
370        einfo 'CPU(s) featuring virtualization technology detected' ; eend 0
371        eoutdent
372      fi
373   fi
374   if [ -d /proc/xen ] ; then
375      eindent
376      einfo 'Running kernel featuring support for Xen detected' ; eend 0
377      eoutdent
378   fi
379 }
380 # }}}
381
382 # {{{ vmware specific stuff
383 config_vmware(){
384 if checkbootparam novmware ; then
385  ewarn "Skipping running vmware specific stuff as requested on boot commandline." ; eend 0
386 else
387  if [ -z "$INSTALLED" ]; then
388   if vmware-detect ; then
389     if [ -r /etc/X11/xorg.conf.vmware ] ; then
390       einfo "Copying /etc/X11/xorg.conf.vmware to /etc/X11/xorg.conf"
391       cp /etc/X11/xorg.conf.vmware /etc/X11/xorg.conf ; eend $?
392     fi
393   fi
394  fi
395 fi
396 }
397 # }}}
398
399 # {{{ ld.so.cache + depmod
400 config_ld_mod(){
401 if [ -n "$INSTALLED" ]; then
402  if ! [ -r /etc/grml.first.boot ] ; then
403   einfo "Running from HD for the first time, regenerate ld.so.cache and modules.dep:"
404   eindent
405 # Regenerate ld.so.cache and module dependencies on HD
406     einfo "Running ldconfig" ; ldconfig  ; eend $?
407     einfo "Running depmod"   ; depmod -a ; eend $?
408     touch /etc/grml.first.boot
409     eend 0
410   eoutdent
411  fi
412 fi
413 }
414 # }}}
415
416 # update_progress {{{
417 update_progress(){
418   # be sure we are non-blocking
419   (echo "$1" > /etc/sysconfig/progress) &
420 }
421 # }}}
422
423 # {{{ timezone
424 config_timezone(){
425  # don't touch the files if running from harddisk:
426  if [ -z "$INSTALLED" ]; then
427   einfo "Setting timezone."
428   KTZ="$(getbootparam tz 2>>$DEBUG)"
429   [ -f "/usr/share/zoneinfo/$KTZ" ] && TZ="$KTZ"
430   rm -f /etc/localtime
431   cp "/usr/share/zoneinfo/$TZ" /etc/localtime && eend 0
432  fi
433 }
434 # }}}
435
436 # small computer / nearly no ram {{{
437 config_small(){
438
439 RAM=$(/usr/bin/gawk '/MemTotal/{print $2}' /proc/meminfo)
440 # MEM=$(/usr/bin/gawk 'BEGIN{m=0};/MemFree|Cached|SwapFree/{m+=$2};END{print m}' /proc/meminfo)
441 eindent
442
443 if checkbootparam "small"; then
444   einfo "Information: ${RAM} kB of RAM available." ; eend 0
445   einfo "Bootoption small detected. Activating small system."
446   if [ -r /etc/inittab.small ] ; then
447     mv /etc/inittab /etc/inittab.normal
448     mv /etc/inittab.small /etc/inittab
449   else
450     sed -i 's/^9/#&/' /etc/inittab
451     sed -i 's/^10/#&/' /etc/inittab
452     sed -i 's/^11/#&/' /etc/inittab
453     sed -i 's/^12/#&/' /etc/inittab
454   fi
455   /sbin/telinit q ; eend $?
456 else
457   if checkgrmlsmall ; then
458     if [[ $RAM -lt 25000 ]] ; then
459       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
460       ewarn "At least 32MB of RAM should be available for grml-small." ; eend 1
461       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
462       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
463       /bin/zsh --login
464     else
465       einfo "Information: ${RAM} kB of RAM available." ; eend 0
466     fi
467   else
468     if [[ $RAM -lt 58000 ]] ; then
469       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
470       ewarn "At least 64MB of RAM should be available for grml." ; eend 1
471       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
472       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
473       /bin/zsh --login
474     else
475       einfo "Information: ${RAM} kB of RAM available." ; eend 0
476     fi
477   fi
478 fi
479 eoutdent
480 }
481 # }}}
482
483 # skip startup of w3m {{{
484 config_fast(){
485 if checkbootparam "fast"; then
486   ewarn "Bootoption fast detected. Skipping startup of w3m."
487     sed -i 's#^1:.*#1:12345:respawn:/usr/bin/openvt -f -c 1 -w -- /bin/zsh#' /etc/inittab
488   /sbin/telinit q ; eend $?
489 fi
490 }
491 # }}}
492
493 # activate serial console {{{
494 config_console(){
495 if checkbootparam "console"; then
496   einfo "Bootoption (for serial) console detected. Activating mgetty."
497     sed -i 's/^#T0/T0/' /etc/inittab
498     sed -i 's/^#T1/T1/' /etc/inittab
499   /sbin/telinit q ; eend $?
500 fi
501 }
502 # }}}
503
504 # For burning on IDE-CD-Roms, k3b (and others) check for special permissions {{{
505 config_cdrom_perm(){
506 CDROMS=""
507 for DEVICE in /proc/ide/hd?; do
508  [ "$(cat $DEVICE/media 2>/dev/null)" = "cdrom" ] && CDROMS="$CDROMS /dev/${DEVICE##*/}"
509 done
510 [ -n "$CDROMS" ] && { chown root.cdrom $CDROMS; chmod 666 $CDROMS; } 2>/dev/null
511 }
512 # }}}
513
514 # {{{ Bring up loopback interface now
515 config_local_net(){
516  if [ -z "$INSTALLED" ] ; then
517     grep -q lo=lo /etc/network/run/ifstate 2>/dev/null || ifup lo
518  fi
519 }
520 # }}}
521
522 # firewire devices {{{
523 # the raw1394 driver does not yet export info into SYSFS,
524 # so let's create raw1394 device manually
525 # http://www.michael-prokop.at/blog/index.php?p=352
526 config_firewire_dev(){
527 if checkbootparam "nofirewiredev" ; then
528   ewarn "Skipping creating some firewire devices as requested on boot commandline." ; eend 0
529 else
530 #if [ "${KERNEL%-*}" == "2.6.11" ] ; then
531   einfo "Creating some firewire devices (fix kernel 2.6-bug)."
532 #  cd /dev && MAKEDEV video1394 raw1394
533   [ -r /dev/raw1394 ]   || mknod /dev/raw1394 c 171 0
534   [ -r /dev/video1394 ] || mknod -m 666 /dev/video1394 c 171 16
535 # mknod -m 666 /dev/dv1394 c 171 32 # for NTSC
536   [ -r /dev/dv1394 ]    || mknod -m 666 /dev/dv1394 c 171 34 # for PAL
537   chown -R root:video /dev/raw1394 /dev/video1394 /dev/dv1394
538   chmod -R 664 /dev/raw1394 /dev/video1394 /dev/dv1394 ; eend $?
539 fi
540 #fi
541 }
542 # }}}
543
544 # {{{ copy passwd-lockfile to ramdisk (fix unionfs-behaviour)
545 # otherwise we will get: passwd: Authentication token lock busy
546 config_fix_passwd(){
547  if [ -z "$INSTALLED" ] ; then
548   touch /etc/.pwd.lock
549  fi
550 }
551 # }}}
552
553 # {{{ CD Checker
554 config_testcd(){
555 if [ -n "$TESTCD" ]; then
556   einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
557   einfo "Reading files and checking against GRML/md5sums, this may take a while..."
558   echo -n "${RED}"
559   ( cd /cdrom/GRML/ ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log )
560   if [ "$?" = "0" ]; then
561     echo " ${GREEN}Everything looks OK${NORMAL}"
562     else
563     echo "${RED} *** CHECKSUM FAILED FOR THESE FILES:                          ***"
564     egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
565     echo "${RED} *** DATA ON YOUR CD MEDIUM IS POSSIBLY INCOMPLETE OR DAMAGED, ***${NORMAL}"
566     echo "${RED} *** OR YOUR COMPUTER HAS BAD RAM.                             ***${NORMAL}"
567     echo -n "${CYAN}Hit return to contine, or press the reset button to quit.${NORMAL}\a\a\a "
568     read a
569   fi
570   eend 0
571 fi
572 }
573 # }}}
574
575 # {{{ hardware detection via discover
576 config_discover(){
577 if checkbootparam "nodisc" ; then
578   ewarn "Skipping hardware detection via discover as requested on boot commandline." ; eend 0
579 else
580  if [ -x /sbin/discover ] ; then
581   einfo "Discovering hardware. Trying to load the following modules in background:"
582    eindent
583    einfo "$(discover --data-path=linux/module/name --data-path=linux/modules/options --format="%s %s" --data-version=`uname -r` --enable-bus all | sort -u | xargs echo)"
584    eoutdent
585   /sbin/discover-modprobe -v 1>>$DEBUG 2>&1 &
586   eend 0
587  else
588   eerror "Application discover not available. Information: udev should handle hardware recognition." ; eend 0
589  fi
590 fi
591 }
592 # }}}
593
594 # {{{ hardware detection via hwinfo
595 config_hwinfo(){
596 if checkbootparam hwinfo >>$DEBUG 2>&1; then
597   einfo "Discovering hardware via hwinfo:"
598   MODULES=$(su grml hwinfo | grep "Cmd: \"modprobe" | awk '{print $5}' | sed 's/"//')
599   echo -n "  Loading modules: "
600   for i in `echo $MODULES` ; do echo -n $i && modprobe $i ; done
601   eend 0
602 fi
603 }
604 # }}}
605
606 # {{{ disable hotplug agents on request
607 config_hotplug_agent(){
608 if checkbootparam "noagent" ; then
609   AGENT="$(getbootparam 'noagent' 2>>$DEBUG)"
610   AGENTLIST=$(echo "$AGENT" | sed 's/,/\\n/g')
611   AGENTNL=$(echo "$AGENT" | sed 's/,/ /g')
612   einfo "Disabling hotplug-agent(s) $AGENTNL"
613   for agent in $(echo -e $AGENTLIST) ; do
614     mv /etc/hotplug/${agent}.rc /etc/hotplug/${agent}.norc
615   done
616   [ "$?" == "0" ] ; eend $?
617 fi
618 }
619 # }}}
620
621 # {{{ blacklist of hotplug-modules
622 config_hotplug_blacklist(){
623 if checkbootparam "black" ; then
624   BLACK="$(getbootparam 'black' 2>>$DEBUG)"
625   BLACKLIST=$(echo "$BLACK" | sed 's/,/\\n/g')
626   BLACKNL=$(echo "$BLACK" | sed 's/,/ /g')
627   einfo "Blacklisting $BLACKNL via /etc/hotplug/blacklist.d/hotplug-light"
628   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist.d/hotplug-light
629   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist
630   eend 0
631 fi
632 }
633 # }}}
634
635 # {{{ run hotplug
636 config_hotplug(){
637 if checkbootparam "nohotplug" ; then
638   ewarn "Skipping running hotplug as requested on boot commandline." ; eend 0
639 else
640   if [ -r /etc/init.d/hotplug ] ; then
641     einfo "Starting hotplug system in background."
642     /etc/init.d/hotplug start 1>>$DEBUG 2>>$DEBUG &
643     eend 0
644   elif [ -r /etc/init.d/hotplug-light ] ; then
645     einfo "Starting hotplug-light system in background."
646     /etc/init.d/hotplug-light start 1>>$DEBUG 2>>$DEBUG &
647     eend 0
648   else
649     ewarn "No hotplug system found. Should be handled by udev. Skipping execution." ; eend 0
650   fi
651 fi
652 }
653 # }}}
654
655 # {{{ blacklist specific module [ used in /etc/init.d/udev ]
656 config_blacklist(){
657 if checkbootparam "blacklist" ; then
658  if [ -z "$INSTALLED" ]; then
659   einfo "Bootoption blacklist found."
660   BLACK="$(getbootparam 'blacklist' 2>>$DEBUG)"
661   if [ -n "$BLACK" ] ; then
662     einfo "Blacklisting module ${BLACK} via /etc/modprobe.d/grml."
663     echo "# begin entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml
664     echo "blacklist $BLACK"     >> /etc/modprobe.d/grml
665     echo "alias     $BLACK off" >> /etc/modprobe.d/grml
666     echo "# end   entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml ; eend $?
667   else
668    eerror "No given module for blacklist found. Blacklisting will not work therefor."
669   fi
670  else
671   ewarn "Backlisting via bootoption does not work on harddisk installations." ; eend 1
672   eindent
673    einfo "Please blacklist the module(s) via /etc/modprobe.d/blacklist."
674   eoutdent
675  fi
676 fi
677 }
678 # }}}
679
680 # {{{ ACPI
681 config_acpi_apm(){
682 if [ -d /proc/acpi ]; then
683   if checkbootparam "noacpi"; then
684     ewarn "Skipping ACPI Bios detection as requested on boot commandline." ; eend 0
685   else
686     einfo "ACPI Bios found, activating modules: "
687     eindent
688     found=""
689     for a in /lib/modules/$KERNEL/kernel/drivers/acpi/*; do
690       basename="${a##*/}"
691       basename="${basename%%.*}"
692       case "$basename" in *_acpi)
693        egrep -qi "${basename%%_acpi}" /proc/acpi/dsdt 2>>$DEBUG || continue ;;
694       esac
695       modprobe $basename >>$DEBUG 2>&1 && found="yes"
696       local BASE="$BASE $basename"
697     done
698     if [ -n "$found" ] ; then
699       einfo "$BASE"  ; eend 0
700     else
701       ewarn "(none)" ; eend 1
702     fi
703     if ! [ -S /var/run/acpid.socket ] ; then
704       if ! [ -r /var/run/dbus/pid ] ; then
705         einfo "Starting acpi daemon."
706         /etc/init.d/acpid start >>$DEBUG ; eend $?
707       else
708         eerror "acpid error: it seems you are running d-bus/hal, but acpid needs to be started before d-bus."
709         eerror "Solution: please activate acpid via /etc/runlevel.conf"
710         eend 1
711       fi
712     else
713       ewarn "acpi daemon already running."
714       eend 0
715     fi
716     eoutdent
717   fi
718 else
719 # APM
720   if checkbootparam "noapm"; then
721     ewarn "Skipping APM Bios detection as requested on boot commandline." ; eend 0
722   else
723     modprobe apm power_off=1 >>$DEBUG 2>&1
724     if [ "$?" = "0" ] ; then
725        if [ -x /etc/init.d/apmd ] ;then
726           einfo "APM Bios found, enabling power management functions."
727           /etc/init.d/apmd start ; eend $?
728        fi
729     else
730       eerror "Loading apm module failed." ; eend 1
731     fi
732   fi
733 fi
734 }
735 # }}}
736
737 # {{{ PCMCIA Check/Setup
738 # This needs to be done before other modules are being loaded (by hwsetup)
739 config_pcmcia(){
740 if checkbootparam "nopcmcia"; then
741   ewarn "Skipping PCMCIA detection as requested on boot commandline." ; eend 0
742 else
743   if /usr/sbin/laptop-detect ; then
744     einfo "Detected Laptop - checking for PCMCIA." && eend 0
745     modprobe pcmcia_core >>$DEBUG 2>&1
746     # Try Cardbus or normal PCMCIA socket drivers
747     modprobe yenta_socket >>$DEBUG 2>&1 || modprobe i82365 >>$DEBUG 2>&1 || modprobe pd6729 >>$DEBUG 2>&1 || modprobe tcic >>$DEBUG 2>&1
748     if [ "$?" = "0" ]; then
749       modprobe ds >>$DEBUG 2>&1
750       if [ -d /proc/bus/pccard ] ; then
751        if [ -x /sbin/cardmgr ] ; then
752         einfo "PCMCIA found, starting cardmgr."
753         cardmgr >>$DEBUG 2>&1 && sleep 6 && eend 0
754        else
755         eerror "No cardmgr found. Make sure package pcmciautils is installed, it should handle it instead." ; eend 1
756        fi
757       fi
758     fi
759   fi
760 fi
761 }
762 # }}}
763
764 # {{{ run software synthesizer via speakup
765 config_swspeak(){
766 if checkbootparam swspeak ; then
767  if [ -d /proc/speakup/ ] ; then
768   einfo "Bootoption swspeak found. Kernel supports speakup." ; eend 0
769   eindent
770    if [ -x /etc/init.d/speech-dispatcher ] ; then
771      einfo "Starting speech-dispatcher."
772      /etc/init.d/speech-dispatcher start 1>>DEBUG ; eend $?
773      einfo "Activating sftsyn in Kernel."
774      echo sftsyn >/proc/speakup/synth_name ; eend $?
775      einfo "Just run swspeak if you want to use software synthesizer via speakup."
776      flite -o play -t "Finished activating software speakup. Just run swspeak when booting finished."
777    else
778     eerror "speech-dispatcher not available. swspeak will not work without it." ; eend 1
779     flite -o play -t "speech-dispatcher not available. speakup will not work without it."
780    fi
781   eoutdent
782  else
783   eerror "Kernel does not seem to support speakup. Skipping swspeak." ; eend 1
784   flite -o play -t "Kernel does not seem to support speakup. Sorry."
785  fi
786 fi
787 }
788 # }}}
789
790 # {{{ Check for blind option or brltty
791 config_blind(){
792 BLIND=""
793 checkbootparam "blind" && BLIND="yes"
794 BRLTTY="$(getbootparam brltty 2>>$DEBUG)"
795
796 if [ -n "$BLIND" -o -n "$BRLTTY" ]; then
797   if [ -x /sbin/brltty ]; then
798     # Blind option detected, start brltty now.
799     # modprobe serial_core parport_serial generic_serial && echo "done"
800     CMD=brltty
801     BRLTYPE=""
802     BRLDEV=""
803     BRLTEXT=""
804     if [ -n "$BRLTTY" ]; then
805       # Extra options
806       BRLTYPE="${BRLTTY%%,*}"
807       R="${BRLTTY#*,}"
808       if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
809         BRLTTY="$R"
810         BRLDEV="${BRLTTY%%,*}"
811         R="${BRLTTY#*,}"
812         if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
813           BRLTTY="$R"
814           BRLTEXT="${BRLTTY%%,*}"
815           R="${BRLTTY#*,}"
816         fi
817       fi
818     fi
819     [ -n "$BRLTYPE" ] && CMD="$CMD -b $BRLTYPE"
820     [ -n "$BRLDEV"  ] && CMD="$CMD -d $BRLDEV"
821     [ -n "$BRLTEXT" ] && CMD="$CMD -t $BRLTEXT"
822     einfo "Starting braille-display manager."
823 #    ( exec $CMD & )
824     ( sh -c "$CMD" & )
825     sleep 2 && BLINDSOUND="yes"
826     eend 0
827   fi
828 fi
829 }
830 # }}}
831
832 # {{{ Interactive configuration
833 config_interactive(){
834 if [ -n "$INTERACTIVE" ] ; then
835 einfo "Entering interactive configuration second stage."
836
837   echo " ${GREEN}Your console keyboard defaults to: ${MAGENTA}${KEYTABLE}"
838   echo -n "${CYAN}Do you want to (re)configure your console keyboard?${NORMAL} [Y/n] "
839   read a
840   [ "$a" != "n" ] && /usr/sbin/dpkg-reconfigure console-data ; eend $?
841
842   echo -n "${CYAN}Do you want to (re)configure your soundcard?${NORMAL} [Y/n] "
843   read a
844   [ "$a" != "n" ] && alsaconf && ( exec aumix -m 0 >>$DEBUG 2>&1 & ) ; eend $?
845
846   echo -n "${CYAN}Do you want to (re)configure your graphics (X11) subsystem?${NORMAL} [Y/n] "
847   read a
848   [ "$a" != "n" ] && xorgcfg -textmode ; eend $?
849   echo " ${GREEN}Interactive configuration finished. Everything else should be fine for now.${NORMAL}"
850 fi
851 eend 0
852 }
853 # }}}
854
855 # {{{ AGP
856 config_agp(){
857 if checkbootparam forceagp ; then
858 # Probe for AGP. Hope this can fail safely
859   stringinfile "AGP" "/proc/pci" 2>>$DEBUG && { modprobe agpgart || modprobe agpgart agp_try_unsupported=1; } >>$DEBUG 2>&1 && einfo "AGP bridge detected." ; eend 0
860 fi
861 }
862 # }}}
863
864 # {{{ automount(er)
865 config_automounter(){
866 if checkbootparam automounter ; then
867   RUNLEVEL="$(runlevel)"
868   AUTOMOUNTER=""
869   [ -x /etc/init.d/autofs ] && [ "$RUNLEVEL" != "N 1" ] && [ "$RUNLEVEL" != "N S" ] && AUTOMOUNTER="yes"
870
871 addautomount(){
872 # /dev/ice  options
873   d="${1##*/}"
874   if [ -n "$AUTOMOUNTER" ]; then
875     [ -d "/mnt/$d" -a ! -L "/mnt/$d" ] && rmdir /mnt/$d
876     [ -d "/mnt/auto/$d" ] || mkdir -p "/mnt/auto/$d"
877     [ -L "/mnt/$d" ]      || ln -s "/mnt/auto/$d" "/mnt/$d"
878     anew="$d        -fstype=auto,$2 :$i"
879     stringinfile "$anew" "/etc/auto.mnt" || echo "$anew" >> /etc/auto.mnt
880     AUTOMOUNTS="$AUTOMOUNTS $d"
881     new="$1 /mnt/auto/$d  auto   users,noauto,exec,$2 0 0"
882   else
883     [ -d /mnt/$d ] && mkdir -p /mnt/$d
884     new="$1 /mnt/$d  auto   users,noauto,exec,$2 0 0"
885   fi
886   stringinfile "$new" "/etc/fstab" || echo "$new" >> /etc/fstab
887 }
888
889   AUTOMOUNTS="floppy cdrom"
890 # Add new devices to /etc/fstab and /etc/auto.mnt
891   for i in /dev/cdrom?*; do
892     if [ -L $i ]; then
893       addautomount "$i" "ro"
894     fi
895   done
896 fi
897
898 if [ -n "$AUTOMOUNTER" ]; then
899 # Check for floppy dir, reinstall with automounter
900   [ -d /mnt/floppy -a ! -L /mnt/floppy ] && rmdir /mnt/floppy
901   [ -d /mnt/auto/floppy ] || mkdir -p /mnt/auto/floppy
902   [ -L /mnt/floppy ] || ln -s /mnt/auto/floppy /mnt/floppy
903   [ -d /mnt/cdrom -a ! -L /mnt/cdrom ] && rmdir /mnt/cdrom
904   [ -d /mnt/auto/cdrom ] || mkdir -p /mnt/auto/cdrom
905   [ -L /mnt/cdrom ] || ln -s /mnt/auto/cdrom /mnt/cdrom
906   rm -f /etc/fstab.new
907 # Replace paths from bootfloppy
908   sed 's|/mnt/cdrom|/mnt/auto/cdrom|g;s|/mnt/floppy|/mnt/auto/floppy|g' /etc/fstab > /etc/fstab.new
909   mv -f /etc/fstab.new /etc/fstab
910 # Start automounter now
911   einfo "Starting automounter for ${AUTOMOUNTS}."
912   /etc/init.d/autofs start >>$DEBUG ; eend $?
913 fi
914 }
915 # }}}
916
917 # {{{ Collect partitions from /proc/partitions first for enabling DMA
918 check_partitions(){
919 partitions=""
920 IDEDISKS=""
921 while read major minor blocks partition relax; do
922   partition="${partition##*/}"
923   [ -z "$partition" -o ! -e "/dev/$partition" ] && continue
924   case "$partition" in
925     hd?) IDEDISKS="$IDEDISKS $partition";;                # IDE  Harddisk, entire disk
926     sd?) ;;                                               # SCSI Harddisk, entire disk
927 #    [hs]d*) partitions="$partitions /dev/$partition";;    # IDE or SCSI disk partition
928     [hs]d*|ub*) partitions="$partitions /dev/$partition";;    # IDE, USB or SCSI disk partition
929   esac
930 done <<EOT
931 $(awk 'BEGIN{old="__start"}{if($0==old){exit}else{old=$0;if($4&&$4!="name"){print $0}}}' /proc/partitions)
932 EOT
933 }
934 check_partitions 1>/dev/null 2>&1 # avoid output "check_partitions:3: read-only file system"
935 # }}}
936
937 # {{{ Enable DMA for all IDE drives now if not disabled
938 # Notice: Already done by linuxrc, but make sure it's done also on harddisk-installed systems
939 config_dma(){
940 if checkbootparam "nodma"; then
941   ewarn "Skipping DMA accelleration as requested on boot commandline." ; eend 0
942 else
943   for d in $(cd /proc/ide 2>>$DEBUG && echo hd[a-z]); do
944     if test -d /proc/ide/$d; then
945       if egrep -q 'using_dma[ \t]+0' /proc/ide/$d/settings 2>>$DEBUG; then
946         MODEL="$(cat /proc/ide/$d/model 2>>$DEBUG)"
947         test -z "$MODEL" && MODEL="[GENERIC IDE DEVICE]"
948         einfo "Enabling DMA acceleration for: ${WHITE}$d        ${YELLOW}[${MODEL}]${NORMAL}"
949         echo "using_dma:1" >/proc/ide/$d/settings
950         eend 0
951       fi
952     fi
953   done
954 fi
955 }
956 # }}}
957
958 # {{{ Start creating /etc/fstab with HD partitions and USB SCSI devices now
959 config_fstab(){
960
961 NOSWAP="yes" # we do not use swap by default!
962 if checkbootparam "swap" -o checkbootparam "anyswap" ; then
963    NOSWAP=''
964 fi
965
966 if checkbootparam "nofstab" -o checkbootparam "forensic" ; then
967   ewarn "Skipping /etc/fstab creation as requested on boot commandline." ; eend 0
968 else
969   checkbootparam "anyswap" && export ANYSWAP='yes' || export ANYSWAP=""
970   einfo "Scanning for harddisk partitions and creating /etc/fstab. (Disable this via boot option: nofstab)"
971   iszsh && setopt nonomatch
972   if [ -x /usr/sbin/rebuildfstab ] ; then
973     config_userfstab || fstabuser=grml
974     /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
975   else
976     ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
977   fi
978   if [ -e /var/run/rebuildfstab.pid ]; then
979     # Another instance of rebuildfstab, probably from hotplug, is still running, so just wait.
980     sleep 8
981   fi
982 fi
983 # Scan for swap, config, homedir
984 if [ -z "$NOSWAP" ]; then
985    einfo "Searching for swap partition(s) as requested."
986 fi
987 GRML_IMG=""
988 GRML_SWP=""
989 HOMEDIR="$(getbootparam home)"
990 if [ -n "$partitions" ]; then
991  while read p m f relax; do
992   case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
993   partoptions="users,exec"
994   fnew=""
995   case "$f" in swap)
996    eindent
997    if [ -n "$NOSWAP" ]; then
998       if [ -z "$INSTALLED" ] ; then
999          ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)" ; eend 0
1000       fi
1001    else
1002      case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
1003              S1SUSP|S2SUSP|pmdisk|[zZ]*)
1004                 if [ -n "$ANYSWAP" ] ; then
1005                   einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
1006                   swapon $p 2>>$DEBUG ; eend $?
1007                 else
1008                   ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
1009                 fi
1010                ;;
1011              *)
1012                 if [[ "$p" == LABEL* ]] ; then
1013                    p=$(blkid -t $p | awk -F: '{print $1}')
1014                 fi
1015                 if grep -q $p /proc/swaps ; then
1016                    ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
1017                 else
1018                    einfo "Using swap partition ${WHITE}${p}${NORMAL}."
1019                    swapon $p 2>>$DEBUG ; eend $?
1020                 fi
1021                ;;
1022      esac
1023    fi
1024    eoutdent
1025    continue
1026    ;;
1027   esac
1028 # Create mountdir if not already present, but don't try to create stuff like /proc/bus/usb
1029 # Notice: grml-rebuildfstab >= 0.3-1 handles this now
1030 #  case "$m" in *none*|*proc*|*sys*|'') continue ;; esac
1031 #  [ -d "$m" ] || mkdir -p "$m"
1032 # WARNING: NTFS RW mounts are only safe since Kernel 2.6.11
1033   [ "$f" = "ntfs" -a "${KERNEL%.*}" != "2.6" ] && continue
1034   MOUNTOPTS="ro"
1035   case "$f" in
1036     vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
1037     ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
1038     *) continue ;;
1039     # *) NONEFOUND='1'; continue ;;
1040   esac
1041   if [ -z "$NOSWAP" ] ; then
1042      mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG || continue
1043      # Activate swapfile, if exists
1044      SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
1045   fi
1046   if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
1047    mount -o remount,rw $m
1048    if swapon "$SWAPFILE" 2>>$DEBUG ; then
1049     einfo "Using GRML swapfile ${SWAPFILE}."
1050     fnew="$SWAPFILE swap swap defaults 0 0"
1051     stringinfile "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
1052     GRML_SWP="$GRML_SWP $SWAPFILE"
1053     eend 0
1054    fi
1055    mount -o remount,ro $m 2>>$DEBUG
1056   fi
1057   IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
1058   if [ -z "$INSTALLED" -a -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
1059    if [ -n "$HOMEDIR" ]; then
1060     if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
1061      continue
1062     fi
1063    fi
1064    if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
1065     GRML_IMG="$IMAGE"
1066     mount -o remount,ro $m 2>>$DEBUG
1067    fi
1068   fi
1069   eend 0
1070   # Umount, if not in use
1071   umount -r $m 2>/dev/null
1072  done <<EOT
1073 $(cat /etc/fstab)
1074 EOT
1075 fi
1076 }
1077 # }}}
1078
1079 # {{{ Mouse
1080 config_mouse(){
1081 if [ -n "$MOUSE_DEVICE" ] ; then
1082   einfo "Detecting mouse: ${MOUSE_FULLNAME} at ${MOUSE_DEVICE}" ; eend $?
1083 fi
1084 }
1085 # }}}
1086
1087 # {{{ IPv6 configuration
1088 # Load IPv6 kernel module and print IP adresses
1089 config_ipv6(){
1090 if checkbootparam "ipv6"; then
1091   einfo "Enabling IPv6 as requested on boot commandline (sleeping for 2 seconds)"
1092   modprobe ipv6
1093   # we probably need some time until stateless autoconfiguration has happened
1094   sleep 2
1095   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1096   for DEVICE in `echo "$NETDEVICES"`; do
1097     eindent
1098       einfo "$DEVICE:"
1099       ADDRESSES="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{print $3}')"
1100       COUNT="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{ sum += 1};END {print sum }')"
1101       eindent
1102         for ADDR in `echo "$ADDRESSES"` ; do
1103             einfo "$ADDR"
1104         done
1105         if [ "$COUNT" -eq "0" ] ; then
1106            einfo "(none)" ; eend 1
1107         fi
1108       eoutdent
1109     eoutdent
1110   done
1111   eend 0
1112 fi
1113 }
1114 # }}}
1115
1116 # {{{ Fat-Client-Version: DHCP Broadcast for IP address
1117 config_dhcp(){
1118 if checkbootparam "nodhcp"; then
1119   ewarn "Skipping DHCP broadcast/network detection as requested on boot commandline." ; eend 0
1120 else
1121   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1122   rm -rf /etc/network/status ; mkdir -p /etc/network/status
1123   for DEVICE in `echo "$NETDEVICES"` ; do
1124     einfo "Network device ${WHITE}${DEVICE}${NORMAL} detected, DHCP broadcasting for IP. (Backgrounding)"
1125     trap 2 3 11
1126     ifconfig $DEVICE up >>$DEBUG 2>&1
1127     ( pump -i $DEVICE >>$DEBUG 2>&1 && echo finished_running_pump > /etc/network/status/$DEVICE ) &
1128     trap "" 2 3 11
1129     sleep 1
1130     eend 0
1131   done
1132 fi
1133 }
1134 # }}}
1135
1136 # {{{ helper functions
1137 findfile(){
1138 FOUND=""
1139 # search all partitions for a file in the root directory
1140 for i in /mnt/[sh]d[a-z] /mnt/[sh]d[a-z][1-9] /mnt/[sh]d[a-z][1-9]?*; do
1141 # See if it's already mounted
1142   [ -f "$i/$1" ] &&  { echo "$i/$1"; return 0; }
1143   if [ -d "$i" ] && mount -r "$i" 2>>$DEBUG; then
1144     [ -f "$i/$1" ] && FOUND="$i/$1"
1145     umount -l "$i" 2>>$DEBUG
1146     [ -n "$FOUND" ] && { echo "$FOUND"; return 0; }
1147   fi
1148 done
1149 return 2
1150 }
1151
1152 fstype(){
1153 case "$(file -s $1)" in
1154   *[Ff][Aa][Tt]*|*[Xx]86*) echo "vfat"; return 0;;
1155   *[Rr][Ee][Ii][Ss][Ee][Rr]*)  echo "reiserfs"; return 0;;
1156   *[Xx][Ff][Ss]*)  echo "xfs"; return 0;;
1157   *[Ee][Xx][Tt]3*) echo "ext3"; return 0;;
1158   *[Ee][Xx][Tt]2*) echo "ext2"; return 0;;
1159   *data*)          echo "invalid"; return 0;;
1160   *) echo "auto"; return 0;;
1161 esac
1162 }
1163
1164 # Try to mount this filesystem read-only, without or with encryption
1165 trymount(){
1166 # Check if already mounted
1167 case "$(cat /proc/mounts)" in *\ $2\ *) return 0;; esac
1168 # Apparently, mount-aes DOES autodetect AES loopback files.
1169 [ -b "$1" ] && { mount -t auto -o ro "$1" "$2" 2>>$DEBUG; RC="$?"; }
1170 # We need to mount crypto-loop files with initial rw support
1171 [ -f "$1" ] && { mount -t auto -o loop,rw "$1" "$2" 2>>$DEBUG; RC="$?"; }
1172 # Mount succeeded?
1173 [ "$RC" = "0" ] && return 0
1174 echo ""
1175 einfo "Filesystem not autodetected, trying to mount $1 with AES256 encryption."
1176 a="y"
1177 while [ "$a" != "n" -a "$a" != "N" ]; do
1178 # We need to mount crypto-loop files with initial rw support
1179  mount -t auto -o loop,rw,encryption=AES256 "$1" "$2" && return 0
1180  echo -n "${RED}Mount failed, retry? [Y/n] ${NORMAL}"
1181  # Problem with ioctl() from getpasswd()?
1182  # read a
1183  read a
1184 done
1185 return 1
1186 }
1187 # }}}
1188
1189 # {{{ CPU-detection
1190 config_cpu(){
1191 if checkbootparam "nocpu"; then
1192   ewarn "Skipping CPU detection as requested on boot commandline." ; eend 0
1193 else
1194   if ! [ -x /etc/init.d/powernowd ] ; then
1195     ewarn "Skipping CPU detection as powernowd dependencies are not fulfilled." ; eend 1
1196   elif [ ! -e /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq -o ! -e /lib/modules/${KERNEL}/kernel/drivers/cpufreq ] ; then
1197     ewarn "Skipping CPU detection as module dependencies are not fulfilled." ; eend 1
1198   else
1199     if [[ `grep -c processor /proc/cpuinfo` -gt 1 ]] ; then
1200       einfo "Detecting CPU:"
1201       CPU=$(awk -F: '/^processor/{printf "      Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
1202       echo $CPU | sed 's/ \{1,\}/ /g'
1203       eend 0
1204     else
1205       einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
1206     fi
1207     if /usr/sbin/laptop-detect ; then
1208     einfo "Detected Laptop - trying to use cpu frequency scaling:"
1209 #      loadcpumod() {
1210 #      for module in /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq/*.ko /lib/modules/${KERNEL}/kernel/drivers/cpufreq/*.ko ; do
1211 #    # modprobe ${${${${(f)"$(_call_program modules ${(M)words[1]##*/}modprobe -l | grep cpufreq 2>>$DEBUG)"}:#}##*/}%.*}
1212 #        modprobe `basename ${module%%\.ko}` 1>>$DEBUG 2>&1
1213 #      done
1214 #      }
1215 #    CPU=$(grep 'model name' /proc/cpuinfo | cut -b14- | head -1)
1216 #    eindent
1217 #    if [[ $CPU = *Intel* ]] ; then
1218 #      einfo "Detected CPU is of type Intel - loading modules and starting cpudyn."
1219 #      local DETECTED=1
1220 #      loadcpumod
1221 #      /etc/init.d/cpudyn start 1>>$DEBUG ; eend $?
1222 #    fi
1223 #    if [[ $CPU = *AMD* ]] ; then
1224 #      einfo "Detected CPU is of type AMD - loading modules and starting powernowd."
1225 #      local DETECTED=1
1226 #      loadcpumod
1227 #      /etc/init.d/powernowd start 1>>$DEBUG ; eend $?
1228 #    fi
1229
1230      eindent
1231      if [ -r /usr/bin/cpufreq-detect.sh ] ; then
1232        . /usr/bin/cpufreq-detect.sh
1233        if [ -n "$MODULE" -a "$MODULE" != none ]; then
1234          einfo "Loading module ${MODULE} and starting powernowd."
1235          modprobe cpufreq_userspace 1>>$DEBUG
1236          modprobe "$MODULE" 1>>$DEBUG || modprobe "$MODULE_FALLBACK" 1>>$DEBUG
1237          /etc/init.d/powernowd start 1>>$DEBUG ; eend $?
1238        else
1239          ewarn "Could not detect an appropriate CPU for use with powernowd - skipping." && eend 1
1240        fi
1241      fi
1242      eoutdent
1243    fi
1244   fi
1245 fi
1246 }
1247 # }}}
1248
1249 # {{{ autostart of ssh
1250 config_ssh(){
1251 if checkbootparam ssh ; then
1252   SSH_PASSWD="$(getbootparam 'ssh' 2>>$DEBUG)"
1253   einfo "Bootoption passwd found."
1254   if [ -n "$SSH_PASSWD" ] ; then
1255     echo "grml:$SSH_PASSWD" | chpasswd -m
1256     einfo "Starting secure shell server in background."
1257     /etc/init.d/rmnologin start 1>>$DEBUG 2>>$DEBUG
1258     /etc/init.d/ssh start 1>>$DEBUG 2>>$DEBUG &
1259     eend 0
1260   else
1261     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1262   fi
1263   eindent
1264     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1265   eoutdent
1266 fi
1267 }
1268 # }}}
1269
1270 # {{{ set password for user grml
1271 config_passwd(){
1272 if checkbootparam passwd >>$DEBUG 2>&1; then
1273   einfo "Bootoption passwd found."
1274   PASSWD="$(getbootparam 'passwd' 2>>$DEBUG)"
1275   if [ -n "$PASSWD" ] ; then
1276     echo "grml:$PASSWD" | chpasswd -m ; eend $?
1277   else
1278     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1279   fi
1280   eindent
1281     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1282   eoutdent
1283 fi
1284 }
1285 # }}}
1286
1287 # {{{ Check for persistent homedir option and eventually mount /home from there, or use a loopback file.
1288 config_homedir(){
1289 if checkbootparam home ; then
1290 HOMEDIR="$(getbootparam home)"
1291 MYHOMEDEVICE=""
1292 MYHOMEMOUNTPOINT=""
1293 MYHOMEDIR=""
1294 if [ -n "$HOMEDIR" ]; then
1295   einfo "Bootoption home detected." && eend 0
1296   case "$HOMEDIR" in
1297     /dev/*)
1298     MYHOMEDEVICE="${HOMEDIR##/dev/}"
1299     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1300     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1301     MYHOMEDIR="/mnt/${HOMEDIR##/dev/}"
1302   ;;
1303     /mnt/*)
1304     MYHOMEDEVICE="${HOMEDIR##/mnt/}"
1305     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1306     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1307     MYHOMEDIR="$HOMEDIR"
1308   ;;
1309     [Aa][Uu][Tt][Oo]|[Ss][Cc][Aa][Nn]|[Ff][Ii][Nn][Dd])
1310     MYHOMEDIR="$(findfile grml.img)"
1311     MYHOMEDEVICE="${MYHOMEDIR##/mnt/}"
1312     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1313     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1314   ;;
1315   *)
1316     eerror "Invalid home= option '$HOMEDIR' specified (must start with /dev/ or /mnt/ or 'scan')." ; eend 1
1317     eerror "Option ignored." ; eend 1
1318   ;;
1319   esac
1320 fi
1321
1322 if [ -n "$MYHOMEDIR" ]; then
1323   if trymount "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"; then
1324     [ -f "$MYHOMEMOUNTPOINT/grml.img" ] && MYHOMEDIR="$MYHOMEMOUNTPOINT/grml.img"
1325     while read device mountpoint fs relax; do
1326       case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
1327         case "$fs" in *[Nn][Tt][Ff][Ss]*)
1328           umount "$MYHOMEMOUNTPOINT"; eerror "Error: will not mount NTFS filesystem on $MYHOMEDEVICE read/write!" ; eend 1
1329           break
1330         ;;
1331         *[Ff][Aa][Tt]*)
1332         # Note: This currently won't work with encrypted partitions
1333         umount "$MYHOMEMOUNTPOINT"; mount -t vfat -o rw,uid=grml,gid=grml,umask=002 "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"
1334         if [ ! -f "$MYHOMEDIR" ]; then
1335           ewarn "WARNING: FAT32 is not a good filesystem option for /home/grml (missing socket/symlink support)."
1336           ewarn "WARNING: Better use an ext2 loopback file on this device, and boot with home=$MYHOMEDEVICE/grml.img."
1337         fi
1338         ;;
1339       esac
1340       if mount -o remount,rw "$MYHOMEMOUNTPOINT"; then
1341         einfo "Mounting ${WHITE}$MYHOMEDIR${NORMAL} as ${WHITE}/home/grml${NORMAL}."
1342         if [ -f "$MYHOMEDIR" ]; then
1343           # It's a loopback file, mount it over the /home/grml directory
1344           trymount "$MYHOMEDIR" /home/grml
1345           RC="$?"
1346           [ "$RC" = "0" ] && ERROR="$(mount -o remount,rw /home/grml 2>&1)"
1347           RC="$?"
1348         else
1349           # Do a --bind mount
1350           ERROR="$(mount --bind "$MYHOMEDIR" /home/grml 2>&1)"
1351           RC="$?"
1352         fi
1353         [ "$RC" = "0" ] && eend 0 || ( eerror "${ERROR}" ; eend 1 )
1354       fi
1355       break
1356       ;;
1357     esac
1358   done <<EOT
1359 $(cat /proc/mounts)
1360 EOT
1361   fi
1362 fi
1363 fi # checkbootparam home
1364 }
1365 # }}}
1366
1367 # {{{ Check for scripts on CD-ROM
1368 config_cdrom_scripts(){
1369 if checkbootparam "script"; then
1370   for script in /cdrom/scripts/* ; do
1371     einfo " grml script found on CD, executing ${WHITE}${script}${NORMAL}."
1372     . $script
1373   done
1374 fi
1375 }
1376 # }}}
1377
1378 # {{{ Sound
1379 config_mixer(){
1380 if ! [ -x /usr/bin/aumix ] ; then
1381   eerror "aumix binary not available. Can not set sound volumes therefore." ; eend 1
1382 else
1383
1384   if checkbootparam vol ; then
1385     VOL="$(getbootparam 'vol' 2>>$DEBUG)"
1386     if [ -z "$VOL" ] ; then
1387       eerror "Bootoption vol found but no volume level/parameter given. Using defaults." ; eend 1
1388       VOL='75' # default
1389     fi
1390   else
1391     VOL='75' # default
1392   fi
1393
1394   if checkbootparam nosound ; then
1395     einfo "Muting sound devices on request."
1396     # some IBM notebooks require the following stuff:
1397     if [ -x /usr/bin/amixer ] ; then
1398        if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1399           amixer set Front unmute 1>/dev/null
1400           amixer set Front 0% 1>/dev/null
1401        fi
1402     fi
1403     ERROR=$(aumix -w 0 -v 0 -p 0 -m 0 2>&1) ; RC=$?
1404     if [ -n "$ERROR" ] ; then
1405        eindent
1406        eerror "Problem muting sound devices: $ERROR"
1407        eoutdent
1408     fi
1409     eend $RC
1410   elif [ -z "$INSTALLED" ]; then
1411       einfo "Setting mixer volumes to level ${WHITE}${VOL}${NORMAL}."
1412       # some IBM notebooks require the following stuff:
1413       if [ -x /usr/bin/amixer ] ; then
1414          if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1415             amixer set Front unmute 1>/dev/null
1416             amixer set Front ${VOL}% 1>/dev/null
1417          fi
1418       fi
1419       ERROR=$(aumix -w $VOL -v $VOL -p $VOL -m $VOL 2>&1) ; RC=$?
1420       if [ -n "$ERROR" ] ; then
1421          eindent
1422          eerror "Problem setting mixer volumes: $ERROR"
1423          eoutdent
1424       fi
1425       eend $RC
1426   fi
1427
1428 fi
1429 }
1430 # }}}
1431
1432 # {{{ modem detection
1433 config_modem(){
1434 if checkbootparam "nomodem"; then
1435   ewarn "Skipping check for AC97 modem controller as requested on boot commandline." ; eend 0
1436 else
1437   if [ -x /etc/init.d/sl-modem-daemon ] ; then
1438    if lspci | grep Intel | grep -q "AC'97 Modem Controller" ; then
1439      einfo "AC97 modem controller detected. Starting sl-modem-daemon in background."
1440      /etc/init.d/sl-modem-daemon start >>$DEBUG &
1441      eend 0
1442    fi
1443   fi
1444 fi
1445 }
1446 # }}}
1447
1448 # {{{ keyboard add-ons
1449 config_setkeycodes(){
1450 if checkbootparam "setkeycodes" ; then
1451  einfo "Setting keycodes as requested via bootparameter 'setkeycodes'."
1452   # MS MM keyboard add-on
1453   # fix
1454   setkeycodes e001 126 &>/dev/null
1455   setkeycodes e059 127 &>/dev/null
1456   # fn keys
1457   setkeycodes e03b 59 &>/dev/null
1458   setkeycodes e008 60 &>/dev/null
1459   setkeycodes e007 61 &>/dev/null
1460   setkeycodes e03e 62 &>/dev/null
1461   setkeycodes e03f 63 &>/dev/null
1462   setkeycodes e040 64 &>/dev/null
1463   setkeycodes e041 65 &>/dev/null
1464   setkeycodes e042 66 &>/dev/null
1465   setkeycodes e043 67 &>/dev/null
1466   setkeycodes e023 68 &>/dev/null
1467   setkeycodes e057 87 &>/dev/null
1468   setkeycodes e058 88 &>/dev/null
1469   # hp keycodes
1470   setkeycodes e00a 89 e008 90 &>/dev/null
1471  eend 0
1472 fi
1473 }
1474 # }}}
1475
1476 # {{{ wondershaper
1477 config_wondershaper(){
1478  if checkbootparam "wondershaper" ; then
1479     WONDER="$(getbootparam wondershaper 2>>$DEBUG)"
1480     CMD=wondershaper
1481     DEVICE=""
1482     DOWNSTREAM=""
1483     UPSTREAM=""
1484     if [ -n "$WONDER" ]; then
1485       # Extra options
1486       DEVICE="${WONDER%%,*}"
1487       R="${WONDER#*,}"
1488       if [ -n "$R" -a "$R" != "$WONDER" ]; then
1489         WONDER="$R"
1490         DOWNSTREAM="${WONDER%%,*}"
1491         R="${WONDER#*,}"
1492         if [ -n "$R" -a "$R" != "$WONDER" ]; then
1493           WONDER="$R"
1494           UPSTREAM="${WONDER%%,*}"
1495           R="${WONDER#*,}"
1496         fi
1497       fi
1498     fi
1499     [ -n "$DEVICE" ]     && CMD="$CMD $DEVICE"
1500     [ -n "$DOWNSTREAM" ] && CMD="$CMD $DOWNSTREAM"
1501     [ -n "$UPSTREAM" ]   && CMD="$CMD $UPSTREAM"
1502     einfo "Starting wondershaper (${CMD}) in background."
1503     ( sh -c $CMD & ) && eend 0
1504  fi
1505 }
1506 # }}}
1507
1508 # {{{ syslog-ng
1509 config_syslog(){
1510  if checkbootparam "nosyslog"; then
1511   ewarn "Not starting syslog-ng as requested on boot commandline." ; eend 0
1512  else
1513   einfo "Starting syslog-ng in background."
1514   /etc/init.d/syslog-ng start 1>>$DEBUG &
1515   eend 0
1516  fi
1517 }
1518 # }}}
1519
1520 # {{{ gpm
1521 config_gpm(){
1522  if checkbootparam "nogpm"; then
1523   ewarn "Not starting GPM as requested on boot commandline." ; eend 0
1524  else
1525   einfo "Starting gpm in background."
1526 #  /etc/init.d/gpm start 1>>$DEBUG &
1527   ( while [ ! -e /dev/psaux ]; do sleep 5; done; /etc/init.d/gpm start 1>>$DEBUG ) &
1528   eend 0
1529  fi
1530 }
1531 # }}}
1532
1533 # {{{ services
1534 config_services(){
1535  if checkbootparam "services" ; then
1536     SERVICE="$(getbootparam services 2>>$DEBUG)"
1537     SERVICELIST=$(echo "$SERVICE" | sed 's/,/\\n/g')
1538     SERVICENL=$(echo "$SERVICE" | sed 's/,/ /g')
1539     einfo "Starting service(s) ${SERVICENL} in background."
1540     for service in $(echo -e $SERVICELIST) ; do
1541        /etc/init.d/${service} start 1>>$DEBUG &
1542     done
1543     [ "$?" == "0" ] ; eend $?
1544  fi
1545 }
1546 # }}}
1547
1548 # {{{ config files
1549 config_netconfig(){
1550  if checkbootparam netconfig ; then
1551   CONFIG="$(getbootparam 'netconfig' 2>>$DEBUG)"
1552   CONFIGFILE='/tmp/netconfig.grml'
1553
1554   getconfig() {
1555   wget --timeout=10 --dns-timeout=10  --connect-timeout=10 \
1556        --read-timeout=10 $CONFIG -O $CONFIGFILE && return 0 || return 1
1557   }
1558   einfo "Trying to get ${WHITE}${CONFIG}${NORMAL}"
1559   counter=10
1560   while ! getconfig && [[ "$counter" != 0 ]] ; do
1561     echo -n "Sleeping for 5 seconds and trying to get config again... "
1562     counter=$(( counter-1 ))
1563     echo "$counter tries left" ; sleep 1
1564   done
1565   if [ -r "$CONFIGFILE" ] ; then
1566     einfo "Downloading was successfull." ; eend 0
1567     einfo "md5sum of ${WHITE}${CONFIG}${NORMAL}: "
1568     md5sum $CONFIGFILE ; eend 0
1569     cd / && einfo "Unpacking ${WHITE}${CONFIGFILE}${NORMAL}:" && /usr/bin/unp $CONFIGFILE $EXTRACTOPTIONS ; eend $?
1570   else
1571     einfo "Sorry, could not fetch $CONFIG" ; eend 1
1572   fi
1573  fi
1574 }
1575 # }}}
1576
1577 # {{{ blindsound
1578 config_blindsound(){
1579  if checkbootparam "blind" ; then
1580     beep
1581     flite -o play -t "welcome to the gremel system"
1582  fi
1583 }
1584 # }}}
1585
1586 # {{{ welcome sound
1587 config_welcome(){
1588  if checkbootparam welcome ; then
1589   flite -o play -t "welcome to the gremel system"
1590  fi
1591 }
1592 # }}}
1593
1594 # {{{ fix/workaround for unionfs
1595 fix_unionfs(){
1596   if [ -z "$INSTALLED" ]; then
1597    touch /var/cache/apt/*cache.bin
1598   fi
1599 }
1600 # }}}
1601
1602 # {{{ create all /mnt-directories
1603 create_mnt_dirs(){
1604   ewarn "create_mnt_dirs is deprecated as grml-rebuildfstab does all we need."
1605   ewarn "Please set CONFIG_CREATE_MNT_DIRS='no' in /etc/grml/autoconfig" ; eend 0
1606 }
1607 # }}}
1608
1609 # {{{ start X window system via grml-x
1610 config_x_startup(){
1611 if checkbootparam startx ; then
1612  if [ -x /usr/X11R6/bin/X ] ; then
1613   if [ -z "$INSTALLED" ] ; then
1614    WINDOWMANAGER="$(getbootparam 'startx' 2>>$DEBUG)"
1615    if [ -z "$WINDOWMANAGER" ] ; then
1616      einfo "No window manager specified. Taking ${WHITE}wm-ng${NORMAL} as default." && eend 0
1617      WINDOWMANAGER="wm-ng"
1618    else
1619      einfo "Window manager ${WHITE}${WINDOWMANAGER}${NORMAL} found as bootoption." && eend 0
1620    fi
1621    einfo "Changing to runlevel 5 for starting grml-x ${WINDOWMANAGER}. Just exit X windows system to get full featured consoles."
1622    config_userfstab || fstabuser='grml'
1623  cat>|/etc/init.d/xstartup<<EOF
1624 #!/bin/sh
1625 # su - $fstabuser -c 'grml-x "$WINDOWMANAGER"'
1626 sudo -u $fstabuser -i /usr/bin/grml-x $WINDOWMANAGER 1>>$DEBUG
1627 EOF
1628    chmod 755 /etc/init.d/xstartup
1629
1630    sed -i 's#^6:.*#6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"#' /etc/inittab
1631    
1632    /sbin/telinit q ; eend $?
1633
1634    if grep -q '^allowed_users=' /etc/X11/Xwrapper.config ; then
1635       sed -i 's/^allowed_users=.*/allowed_users=anybody/' /etc/X11/Xwrapper.config
1636    else
1637       echo 'allowed_users=anybody' >> /etc/X11/Xwrapper.config
1638    fi
1639
1640   else
1641     eerror "We are not running from CD - startx will not work, skipping it.
1642      Please use something like xdm, gdm or kdm for starting X on a harddisk system!" ; eend 1
1643   fi
1644  else
1645    eerror "/usr/X11R6/bin/X is not present on this grml flavour.
1646    Boot parameter startx does not work therefore." ; eend 1
1647  fi
1648 fi
1649 }
1650 # }}}
1651
1652 # {{{ configuration framework
1653 config_extract(){
1654 if checkbootparam extract ; then
1655  EXTRACT="$(getbootparam 'extract' 2>>$DEBUG)"
1656  EXTRACTOPTIONS="-- -x $EXTRACT"
1657 fi
1658 }
1659
1660 config_automount(){
1661 if checkbootparam noautoconfig -o checkbootparam forensic ; then
1662   ewarn "Skipping running automount of device(s) labeled GRMLCFG as requested." ; eend 0
1663 else
1664  if [ -z "$INSTALLED" ] ; then
1665   einfo "Searching for device(s) labeled with GRMLCFG." ; eend 0
1666   eindent
1667   [ -d /mnt/grml ] || mkdir /mnt/grml
1668   umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1669 # We do need the following fix so floppy disk is available to blkid in any case :-/
1670   if [ -r /dev/fd0 ] ; then
1671      einfo "Floppy device detected. Trying to access floppy disk. (Disable this via boot option: noautoconfig)"
1672 #     dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1
1673      if timeout 4 dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1 ; then
1674         blkid /dev/fd0 1>>$DEBUG 2>&1
1675      fi
1676   fi
1677   DEVICE=$(blkid -t LABEL=GRMLCFG | head -1 | awk -F: '{print $1}')
1678   [ -n "$DEVICE" ] && mount -t auto -o ro $DEVICE /mnt/grml ; RC="$?"
1679   if [[ $RC == 0 ]]; then
1680     einfo "Mounting device $DEVICE labeled GRMLCFG succeeded." ; eend 0
1681
1682     CONFIG=''
1683     CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1684     if [ -n "$CONFIG" ]; then
1685       einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1686       cd /
1687       unp $CONFIG $EXTRACTOPTIONS ; eend $?
1688     else
1689       ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1690     fi
1691
1692     SCRIPT=''
1693     SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1694     if [ -n "$SCRIPT" ]; then
1695       einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1696       $SCRIPT ; eend $?
1697     fi
1698     grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1699   else
1700     ewarn "No devices with label GRMLCFG found." ; eend 0
1701   fi
1702   eoutdent
1703  fi
1704 fi
1705 }
1706
1707 config_myconfig(){
1708
1709 if checkbootparam "config" ; then
1710   CONFIG="$(getbootparam 'config' 2>>$DEBUG)"
1711   [ -z "$CONFIG" ] && CONFIG='config.tbz'
1712   einfo "Bootoption config found. config is set to: $CONFIG"
1713   eindent
1714     einfo "Trying to extract configuration file ${CONFIG}:"
1715     cd / && unp /cdrom/config/$CONFIG $EXTRACTOPTIONS ; eend $?
1716   eoutdent
1717 fi
1718
1719 if checkbootparam myconfig ; then
1720  MOUNTDEVICE="$(getbootparam 'myconfig' 2>>$DEBUG)"
1721  if [ -n "$MOUNTDEVICE" ]; then
1722    if checkbootparam file ; then
1723     FILENAME="$(getbootparam 'file' 2>>$DEBUG)"
1724     [ -n "$FILENAME" ] || FILENAME='config.tbz'
1725    fi
1726    [ -d /mnt/grml ] || mkdir /mnt/grml
1727    umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1728    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1729     if [[ $RC == 0 ]]; then
1730       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1731       eindent
1732       CONFIG=''
1733       CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1734       if [ -n "$CONFIG" ]; then
1735         einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1736         cd /
1737         unp $CONFIG $EXTRACTOPTIONS ; eend $?
1738       else
1739         ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1740       fi
1741
1742       SCRIPT=''
1743       SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1744       if [ -n "$SCRIPT" ]; then
1745         einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1746         $SCRIPT ; eend $?
1747       fi
1748       eoutdent
1749     else
1750       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1751     fi # mount $MOUNTDEVICE
1752    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1753  else
1754    einfo "Sorry, no device for bootoption myconfig provided. Skipping." ; eend 1
1755  fi # [ -n "$MOUNTDEVICE" ]
1756 fi # checkbootparam myconfig
1757
1758 if checkbootparam "partconf" ; then
1759  MOUNTDEVICE="$(getbootparam 'partconf' 2>>$DEBUG)"
1760  if [ -n "$MOUNTDEVICE" ]; then
1761    [ -d /mnt/grml ] || mkdir /mnt/grml
1762    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1763     if [[ $RC == 0 ]]; then
1764       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1765       einfo "Copying files from $MOUNTDEVICE over grml system."
1766       for file in `cat /etc/grml/partconf` ; do
1767         [ -d /mnt/grml/$file ] && cp -a /mnt/grml/${file}* ${file} && echo "copied: $file"
1768         [ -f /mnt/grml/$file ] && cp -a /mnt/grml/${file}  ${file} && echo "copied: $file"
1769       done && eend 0
1770     else
1771       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1772     fi # mount $MOUNTDEVICE
1773    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1774  else
1775    einfo "Sorry, no device for bootoption partconf provided. Skipping." ; eend 1
1776  fi # [ -n "$MOUNTDEVICE" ]
1777 fi
1778 }
1779 # }}}
1780
1781 # {{{ /cdrom/.*-options
1782 config_debs(){
1783 if checkbootparam "debs" ; then
1784   DEBS="$(getbootparam 'debs' 2>>$DEBUG)"
1785   einfo "Tring to install debian package(s) ${DEBS}"
1786   dpkg -i /cdrom/debs/$DEBS* ; eend $?
1787 fi
1788 }
1789
1790 config_scripts(){
1791 if checkbootparam "scripts" ; then
1792   SCRIPTS="$(getbootparam 'scripts' 2>>$DEBUG)"
1793   [ -z "$SCRIPTS" ] && SCRIPTS='grml.sh'
1794   einfo "Bootparameter scripts found. Trying to execute ${SCRIPTS}:"
1795   sh -c /cdrom/scripts/$SCRIPTS ; eend $?
1796 fi
1797 }
1798 # }}}
1799
1800 # {{{ distcc
1801 config_distcc(){
1802 if checkbootparam "distcc" ; then
1803  OPTIONS="$(getbootparam distcc 2>>$DEBUG)"
1804  if [ -n "$OPTIONS" ]; then
1805     NET=""
1806     INTERFACE=""
1807     if [ -n "$OPTIONS" ]; then
1808       NET="${OPTIONS%%,*}"
1809       R="${OPTIONS#*,}"
1810       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1811         OPTIONS="$R"
1812         INTERFACE="${OPTIONS%%,*}"
1813         R="${OPTIONS#*,}"
1814       fi
1815     fi
1816  fi
1817  CONFIG=/etc/default/distcc
1818  sed -i "s#^STARTDISTCC=.*#STARTDISTCC=YES#"  $CONFIG
1819  sed -i "s#^ALLOWEDNETS=.*#ALLOWEDNETS=$NET#" $CONFIG
1820
1821  if [ -n "$INTERFACE" ] ; then
1822    IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
1823
1824    counter=10
1825    while [ -z "$IP" ] && [[ "$counter" != 0 ]] ; do
1826      counter=$(( counter-1 ))
1827      ewarn "No ip address for $INTERFACE found. Sleeping for 3 seconds. $counter tries left."
1828      sleep 3
1829      IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
1830    done
1831  fi
1832
1833  if [ -n "$IP" ] ; then
1834    sed -i "s#^LISTENER=.*#LISTENER=$IP#"      $CONFIG
1835
1836    einfo "Bootoption distcc found. Preparing setup for distcc daemon."
1837    eindent
1838     id distccd >/dev/null 2>&1 || \
1839     (
1840       einfo "Creating distcc user" ; \
1841       adduser --quiet --system --ingroup nogroup --home / --no-create-home distccd ; eend $?
1842     )
1843
1844     einfo "Starting distcc for network ${NET}, listening on ${IP}."
1845    /etc/init.d/distcc start 1>/dev/null ; eend $?
1846    eoutdent
1847  else
1848    eerror "No ip address for $INTERFACE found. distcc can not be used without it." ; eend 1
1849  fi
1850 fi
1851
1852 if checkbootparam "gcc"; then
1853  GCC="$(getbootparam gcc 2>>$DEBUG)"
1854  eindent
1855  einfo "Pointing /usr/bin/gcc to /usr/bin/gcc-${GCC}."
1856  eoutdent
1857  rm -f /usr/bin/gcc
1858  ln -s /usr/bin/gcc-${GCC} /usr/bin/gcc ; eend $?
1859 fi
1860
1861 if checkbootparam "gpp"; then
1862  GPP="$(getbootparam gpp 2>>$DEBUG)"
1863  eindent
1864   einfo "Pointing /usr/bin/g++ to /usr/bin/g++-${GPP}."
1865   if [ -x /usr/bin/g++-${GPP} ] ; then
1866      rm -f /usr/bin/g++
1867      ln -s /usr/bin/g++-${GPP} /usr/bin/g++ ; eend $?
1868   fi
1869   einfo "Pointing /usr/bin/cpp to /usr/bin/cpp-${GPP}."
1870   if [ -x /usr/bin/cpp-${GPP} ] ; then
1871      rm -f /usr/bin/cpp
1872      ln -s /usr/bin/cpp-${GPP} /usr/bin/cpp ; eend $?
1873   fi
1874  eoutdent
1875 fi
1876
1877 }
1878 # }}}
1879
1880 # {{{ load modules
1881 # Notice: use it only on live-cd system, if running from harddisk please
1882 # add modules to /etc/modules and activate /etc/init.d/module-init-tools
1883 # in /etc/runlevel.conf
1884 config_modules(){
1885 MODULES_FILE=/etc/grml/modules
1886 if checkbootparam nomodules ; then
1887   ewarn "Skipping loading of modules defined in ${MODULES_FILE} as requested." ; eend 0
1888 elif [ -z "$INSTALLED" ]; then
1889  if [ -r $MODULES_FILE ] ; then
1890   einfo "Loading modules specified in ${MODULES_FILE}:"
1891   eindent
1892   grep '^[^#]' $MODULES_FILE | \
1893   while read module args; do
1894     [ "$module" ] || continue
1895       einfo "${module}"
1896       modprobe $module $args ; eend $?
1897   done
1898   eoutdent
1899  else
1900   ewarn "File $MODULES_FILE does not exist. Skipping loading of specific modules." ; eend 1
1901  fi
1902 fi
1903 }
1904 # }}}
1905
1906 # {{{ 915resolution
1907 config_915resolution(){
1908 if checkbootparam "915resolution" ; then
1909  OPTIONS="$(getbootparam 915resolution 2>>$DEBUG)"
1910   if [ -x /usr/sbin/915resolution ]; then
1911     CMD=915resolution
1912     MODE=""
1913     XRESO=""
1914     YRESO=""
1915     if [ -n "$OPTIONS" ]; then
1916       # Extra options
1917       MODE="${OPTIONS%%,*}"
1918       R="${OPTIONS#*,}"
1919       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1920         OPTIONS="$R"
1921         XRESO="${OPTIONS%%,*}"
1922         R="${OPTIONS#*,}"
1923         if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1924           OPTIONS="$R"
1925           YRESO="${OPTIONS%%,*}"
1926           R="${OPTIONS#*,}"
1927         fi
1928       fi
1929     fi
1930     einfo "Running 915resolution with options ${MODE} ${XRESO} ${YRESO}."
1931     [ -n "$MODE" ] && [ -n "$XRESO"  ] && [ -n "$YRESO" ]  && ( sh -c "$CMD $MODE $XRESO $YRESO" & )
1932     eend 0
1933   fi
1934 fi
1935 }
1936 # }}}
1937
1938 # {{{ SW-RAID
1939 config_swraid(){
1940   if [ -z "$INSTALLED" ] ; then
1941   # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
1942   if checkbootparam 'noraid'   -o checkbootparam 'noswraid' -o \
1943      checkbootparam 'forensic' -o checkbootparam 'raid=noautodetect' ; then
1944      ewarn "Skipping SW-RAID code as requested on boot commandline." ; eend 0
1945   else
1946     if ! [ -x /sbin/mdadm ] ; then
1947        eerror "mdadm not available, can not execute it." ; eend 1
1948     else
1949
1950        # if ! egrep -qv '^(MAILADDR.*|#.*|)$' /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
1951        # find out whether we have a valid configuration file already
1952        if ! grep -q ARRAY /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
1953           einfo "Creating /etc/mdadm/mdadm.conf for use with mdadm."
1954           [ -r /etc/mdadm/mdadm.conf ] && mv /etc/mdadm/mdadm.conf /etc/mdadm/mdadm.conf.old
1955           MDADM_MAILADDR__='root' /usr/share/mdadm/mkconf > /etc/mdadm/mdadm.conf ; eend $?
1956         else
1957           ewarn "/etc/mdadm/mdadm.conf looks like a configured mdadm setup, will not touch it." ; eend 0
1958        fi
1959
1960        if ! checkbootparam 'swraid' ; then
1961           eindent
1962           einfo "Just run 'Start mdadm-raid' to assemble md arrays or boot using 'swraid' as bootoption for autostart."
1963           eoutdent
1964        else
1965           einfo "Bootoption swraid found. Searching for software RAID arrays:"
1966           eindent
1967            IFSOLD=${IFS:-}
1968            IFS='
1969 '
1970            for line in $(mdadm --assemble --scan --auto=yes --symlink=no 2>&1) ; do
1971                case $line in
1972                  *'No arrays found'*)
1973                    ewarn "$line" ; eend 0
1974                    ;;
1975                  *)
1976                    einfo "$line" ; eend 0
1977                    ;;
1978                esac
1979            done
1980            IFS=$IFSOLD
1981          eoutdent
1982
1983          if [ -r /proc/mdstat ] ; then
1984             eindent
1985             MDSTAT=$(grep '^md[0-9]' /proc/mdstat)
1986             if [ -z "$MDSTAT" ] ; then
1987                ewarn "No active arrays found" ; eend 0
1988             else
1989                IFSOLD=${IFS:-}
1990                IFS='
1991 '
1992                for line in $(grep '^md[0-9]' /proc/mdstat) ; do
1993                    einfo "active arrays: $line" ; eend 0
1994                done
1995                IFS=$IFSOLD
1996             fi
1997             eoutdent
1998          fi # /proc/mdstat
1999        fi # bootoption swraid
2000
2001      fi # is /sbin/mdadm executable?
2002   fi # check for bootoptions
2003   fi # run only in live-cd mode
2004 }
2005 # }}}
2006
2007 # {{{ debnet: setup network based on an existing one found on a partition
2008 config_debnet(){
2009 if checkbootparam "debnet" ; then
2010  iszsh && setopt shwordsplit
2011  DEVICES="$(< /proc/partitions tail -n +3 | awk '{print "/dev/"$4}' | tr "\n" " ")"
2012  DEVICES="$DEVICES $(ls /dev/mapper/*)"
2013  FOUND_DEBNET=""
2014
2015  einfo "Bootoption 'debnet' found. Searching for Debian network configuration: "
2016  eindent
2017  if ! mount | grep '/mnt ' 1>/dev/null 2>&1 ; then
2018     for i in $DEVICES; do
2019      if mount -o ro -t auto "$i" /mnt >/dev/null 2>&1; then
2020          einfo "Scanning on $i"
2021        if [ -f /mnt/etc/network/interfaces ]; then
2022          einfo "/etc/network/interfaces found on ${i}" ; eend 0
2023          FOUND_DEBNET="$i"
2024          break
2025        fi
2026        umount /mnt
2027      fi
2028     done
2029
2030    if [ -n "$FOUND_DEBNET" ]; then
2031      einfo "Stopping network."
2032        pump -k 1>/dev/null 2>&1
2033        /etc/init.d/networking stop 1>/dev/null 2>&1 ; eend $?
2034      einfo "Copying Debian network configuration from $FOUND_DEBNET to running system."
2035        rm -rf /etc/network/run
2036        cp -a /mnt/etc/network /etc
2037        rm -rf /etc/network/run
2038        mkdir /etc/network/run
2039        umount /mnt ; eend $?
2040      einfo "Starting network."
2041        /etc/init.d/networking start ; eend $?
2042    else
2043      eerror "/etc/network/interfaces not found." ; eend 1
2044    fi
2045    eoutdent
2046  else
2047   eerror "Error: /mnt already mounted." ; eend 1
2048  fi
2049 fi
2050 }
2051 # }}}
2052
2053 # {{{ disable console blanking
2054 config_blanking(){
2055 if checkbootparam "noblank" ; then
2056   einfo "Bootoption noblank found. Disabling monitor blanking."
2057   setterm -blank 0 ; eend $?
2058 fi
2059 }
2060 # }}}
2061
2062 # {{{ grml2hd: automatic installation
2063 config_grml2hd(){
2064
2065 if checkbootparam "user" ; then
2066   NEWUSER=''
2067   NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
2068   sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2069 fi
2070
2071 if checkbootparam "filesystem" ; then
2072   FILESYSTEM=''
2073   FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
2074   sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2075 fi
2076
2077 if checkbootparam "partition" ; then
2078   PARTITION=''
2079   PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
2080   # notice: the following checks whether the given partition is available, if not the skip
2081   # execution of grml2hd as it might result in data loss...
2082   if [ -r $PARTITION ] ; then
2083     sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2084   else
2085     ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
2086   fi
2087 fi
2088
2089 if checkbootparam "mbr" ; then
2090   BOOT_PARTITION=''
2091   BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
2092   sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2093 fi
2094
2095 if stringinstring "BOOT_IMAGE=grml2hd " "$CMDLINE" ; then
2096   cat>|/usr/bin/grml2hd_noninteractive<<EOF
2097 #!/bin/sh
2098 GRML2HD_NONINTERACTIVE='yes' grml2hd
2099 EOF
2100   chmod 755 /usr/bin/grml2hd_noninteractive
2101   einfo "Bootparameter grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
2102   if [ -z "$GRML2HD_FAIL" ] ; then
2103     screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
2104   else
2105     ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
2106   fi
2107 fi
2108 }
2109 # }}}
2110
2111 ### {{{ backwards compatible stuff
2112 config_environment(){
2113   ewarn "config_environment is deprecated. Please set CONFIG_ENVIRONMENT in /etc/grml/autoconfig to 'no'." ; eend 0
2114 }
2115 config_keyboard(){
2116   ewarn "config_keyboard is deprecated. Please set CONFIG_KEYBOARD in /etc/grml/autoconfig to 'no'." ; eend 0
2117 }
2118 # }}}
2119
2120 ## END OF FILE #################################################################
2121 # vim:foldmethod=marker